SystemOrganization addCategory: #AMMStudio!
SystemOrganization addCategory: #'AMMStudio-Test'!

NCSimulatedAnnealingGraphLayoutAlgorithm subclass: #AMMGraphLayoutAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:24:15.512'!
aeMinEdgeLength
	"sw: I had to change this, hence errors came up, after removing the PasteUpMorph, although the layout algorithm is still active."
	
	"I am an aesthetic that causes edges to be shortened. My magnitude is d^2, where d is the magnitude of the distance between nodes. Since I consider all edges, my time complexity is O(|E|)"

	| retval |
	retval := IdentityDictionary 
				newFrom: (self nodes collect: [:node | node -> (0 @ 0)]).
	self edges do: 
			[:edge | 
			| fromNode toNode delta mag force |
			fromNode := edge startConnection.
			toNode := edge endConnection.
			((fromNode isNil) or: toNode isNil) ifFalse: [
				delta := toNode center - fromNode center.
				delta := delta / scale.
				mag := delta r.
				force := mag * delta.
				retval at: fromNode put: (retval at: fromNode) + force.
				retval at: toNode put: (retval at: toNode) - force].
			].	

   ^self nodes collect: [:ea | retval at: ea]! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:12:12.787'!
aeNodeRepulsion
	"I am an aesthetic that attempts to keep nodes apart. My magnitude is 1/d^2, where d is the magnitude of the distance between nodes. Since I consider all node combinations, my time complexity is O(|V|^2)"

	| retval |
	retval := Array new: self nodes size withAll: 0.0 @ 0.0.
	(1 to: self nodes size) combinations: 2
		atATimeDo: 
			[:arr | 
			| ai1 ai2 node otherNode delta mag2 force |
			 "self halt."
			node := self nodes at: (ai1 := arr at: 1).
			otherNode := self nodes at: (ai2 := arr at: 2).
			delta := (node center - otherNode center) asFloatPoint.
			delta := (delta / scale) + 0.001.
			mag2 := delta x * delta x + (delta y * delta y) max: 1.0e-8.
			force := 1.0 / mag2 * delta.
			retval at: ai1 put: (retval at: ai1) + force.
			retval at: ai2 put: (retval at: ai2) - force].
	^retval! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:47:50.721'!
layoutMorph: aPasteUpMorph 
	aPasteUpMorph allConnectedMorphs isEmpty ifFalse: [
		^ super layoutMorph: aPasteUpMorph
		]! !

UserInterface subclass: #AMMObejctTreeNodeUi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObejctTreeNodeUi methodsFor: 'ui - private' stamp: 'sw 4/29/2013 13:56:44.074'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 |
	
	panel := UiContainer new.
	panel extent: (41@41).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.949)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := CircleMorph new.
	unnamedMorph1 extent: (40@40).
	unnamedMorph1 position: (0@0).
	unnamedMorph1 hResizing: (#rigid).
	unnamedMorph1 vResizing: (#rigid).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.949)).
	panel addChild: unnamedMorph1.
	panel setProperty: #uiClassName toValue: 'AMMObejctTreeNode'.! !

UserInterface subclass: #AMMStudioUi
	instanceVariableNames: 'btnStep scrollarea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/9/2013 11:03:40.337'!
btnStep
	"No description given."
	
	^ btnStep! !

!AMMStudioUi methodsFor: 'ui - private' stamp: 'sw 5/9/2013 11:03:40.447'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (500@300).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 extent: (492@63).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#rigid).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	btnStep := UiPushButton new.
	btnStep changeTableLayout.
	btnStep extent: (31@21).
	btnStep position: (20@44).
	btnStep hResizing: (#shrinkWrap).
	btnStep vResizing: (#shrinkWrap).
	btnStep minWidth: (2).
	btnStep minHeight: (2).
	btnStep cellInset: (4).
	btnStep cellPositioning: (#center).
	btnStep cellSpacing: (#none).
	btnStep layoutInset: (2@0 corner: 2@0).
	btnStep listCentering: (#topLeft).
	btnStep listDirection: (#leftToRight).
	btnStep listSpacing: (#none).
	btnStep maxCellSize: (1073741823).
	btnStep minCellSize: (0).
	btnStep wrapCentering: (#topLeft).
	btnStep wrapDirection: (#none).
	btnStep frameFractions: (0@0 corner: 1@1).
	btnStep frameOffsets: (0@0 corner: 0@0).
	btnStep balloonText: (nil).
	btnStep balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	btnStep enabled: (true).
	btnStep setProperty: #iconByDesigner toValue: 'nil'.
	btnStep icon: (nil).
	btnStep text: ('step').
	btnStep color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	btnStep checkable: (false).
	btnStep checked: (false).
	btnStep autoExclusive: (false).
	btnStep setProperty: #objectName toValue: 'btnStep'.
	unnamedMorph1 addChild: btnStep.
	panel addChild: unnamedMorph1.
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (492@225).
	unnamedMorph2 position: (4@71).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#spaceFill).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.945)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	scrollarea := ViScrollArea new.
	scrollarea extent: (484@217).
	scrollarea position: (8@75).
	scrollarea hResizing: (#spaceFill).
	scrollarea vResizing: (#spaceFill).
	scrollarea minWidth: (2).
	scrollarea minHeight: (2).
	scrollarea cellInset: (0).
	scrollarea cellPositioning: (#center).
	scrollarea cellSpacing: (#none).
	scrollarea layoutInset: (0).
	scrollarea listCentering: (#topLeft).
	scrollarea listDirection: (#topToBottom).
	scrollarea listSpacing: (#none).
	scrollarea maxCellSize: (1073741823).
	scrollarea minCellSize: (0).
	scrollarea wrapCentering: (#topLeft).
	scrollarea wrapDirection: (#none).
	scrollarea frameFractions: (0@0 corner: 1@1).
	scrollarea frameOffsets: (0@0 corner: 0@0).
	scrollarea balloonText: (nil).
	scrollarea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	scrollarea widgetResizable: (false).
	scrollarea horizontalScrollBarPolicy: (#alwaysOn).
	scrollarea verticalScrollBarPolicy: (#alwaysOn).
	scrollarea outerBorderWidth: (0).
	scrollarea scrollBarThickness: (9).
	scrollarea setProperty: #objectName toValue: 'scrollarea'.
	unnamedMorph2 addChild: scrollarea.
	panel addChild: unnamedMorph2.
	panel setProperty: #uiClassName toValue: 'AMMStudio'.! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 5/9/2013 11:03:40.38'!
scrollarea
	"No description given."
	
	^ scrollarea! !

Morph subclass: #AMMStudio
	instanceVariableNames: 'ui heap objectgraph gcAlgorithm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudio class methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:19:33.161'!
open

	^ self new open.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:16:26.137'!
gcAlgorithm

	^ gcAlgorithm! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:16:09.73'!
gcAlgorithm: anAlgorithm

	gcAlgorithm := anAlgorithm.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:25:57.307'!
gcStep

	self gcAlgorithm gcStep.
	self refreshObjectRepresentations.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 21:03:11.779'!
heap

	^heap ifNil: [ heap := AMMHeap new ]! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:23:52.425'!
initialize 

	super initialize.
	self ui setupUi: self.
	self initializeScrollArea.
		
	self connect: self ui btnStep  signal:#clicked: toSelector: #gcStep.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:15:09.496'!
initializeScrollArea 
| area |
	area := Morph new extent: 2000@1000.
	self ui scrollarea widget: area.
	self objectgraph position: 200@0.
	area addMorph: self objectgraph.
	area addMorph: self heap.
	
! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:25:26.214'!
markAndSweep
| objects |

	self gcAlgorithm: AMMGCAlgorithm new.
	objects := AMMObjectGraphTest exampleCollectionWithoutCircularyDepencies.
	self gcAlgorithm objects: objects.
	self heap objects: objects.
	self objectgraph objects: objects.
	self refreshObjectRepresentations.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 21:03:38.883'!
objectgraph

	^ objectgraph ifNil: [ objectgraph := AMMObjectGraph new]! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 4/29/2013 12:13:42.2'!
open
	self openInWindowLabeled: 'AMM Studio'.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:25:42.299'!
refreshObjectRepresentations

	self objectgraph refresh.
	self heap refresh.! !

!AMMStudio methodsFor: 'as yet unclassified' stamp: 'sw 4/29/2013 12:05:54.615'!
ui
	
	^ ui ifNil: [ ui:= AMMStudioUi new ]! !

Morph subclass: #AMMTestMorph
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTestMorph methodsFor: 'as yet unclassified' stamp: 'sw 4/29/2013 14:01:16.086'!
initialize 

	super initialize.
	self ui setupUi: self.! !

!AMMTestMorph methodsFor: 'as yet unclassified' stamp: 'sw 4/29/2013 14:00:10.567'!
ui

	^ ui ifNil: [ ui := AMMObejctTreeNodeUi new]! !

UiTestCase subclass: #AMMObjectGraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMObjectGraphTest class methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:49:52.069'!
exampleCollectionWithoutCircularyDepencies
	
	| objA objB objC coll |
	objA := AMMObject new size: 8.
	objB := AMMObject new size: 20.
	objC := AMMObject new size: 5.
	objA references add: objB; add:objC.	

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		yourself.
	^ coll! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:03:38.691'!
subjectClass

	^ AMMObjectGraph! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:06:11.201'!
testANewObjectGraphHasNoNodes

	self assert: sut objectNodes size == 0.
	self assert: sut submorphs size == 0.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:26:42.366'!
testRenderingConnectsNodes
	

	sut objects: self class exampleCollectionWithoutCircularyDepencies.
	
	self assert: sut objectNodes isEmpty.

	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:13:52.694'!
testRenderingCreatesObjectNodes
	
	sut objects add: (AMMObject new size: 8).
	self assert: sut objectNodes isEmpty.
	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:26:57.258'!
testRenderingPreservesObjects
	
	self assert: sut objects isEmpty.
	sut objects: self class exampleCollectionWithoutCircularyDepencies.
	self deny: sut objects isEmpty.
	sut render.
	self deny: sut objects isEmpty.	! !

PasteUpMorph subclass: #AMMObjectsRepresentation
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMObjectsRepresentation subclass: #AMMHeap
	instanceVariableNames: 'heapCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeap class methodsFor: 'as yet unclassified' stamp: 'rm 5/6/2013 15:15:08.484'!
withSize: aHeapSize

	| heap |
	heap := AMMHeap new.
	heap extent: ((aHeapSize*10)@100);
		borderWidth: 0;
		color: Color transparent.
	1 to: aHeapSize do: [ :cellNumber | 
		| cell |
		cell := AMMHeapCell withId: cellNumber.
		cell position: ( (10*(cellNumber-1)) @ 0).
		cell lock.
		heap heapCollection add: cell.
	].
	^ heap! !

!AMMHeap methodsFor: 'rendering' stamp: 'rm 5/6/2013 14:25:34.113'!
clearHeap

	" remove all submorphs and empty all dictionaries/ collections"
	
	self heapCollection do: [ :element |
			element reset.
			element delete.
		] ! !

!AMMHeap methodsFor: 'rendering' stamp: 'rm 5/6/2013 14:31:19.782'!
createHeap
	"create entries for all objects"
	
	self heapCollection do: [ :element |
			self addMorph: element.
		]
	! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:44.341'!
heapCollection
	
	 ^ heapCollection ifNil: [ heapCollection := OrderedCollection new ]! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:59.241'!
heapSize

	^ self heapCollection size! !

!AMMHeap methodsFor: 'rendering' stamp: 'rm 5/6/2013 15:21:17.898'!
mapObjectsToHeap
	" iterates over objects and marks used heap cells "
	
	self objects do: [ :object |
			| cell |
			0 to: (object size - 1) do: [ :offset |
				(self heapCollection size >= (object address + offset)) ifTrue: [
					cell := self heapCollection at: (object address + offset). 
					cell setStatus: 2.
				]
			]
		]! !

!AMMHeap methodsFor: 'rendering' stamp: 'rm 5/6/2013 14:15:50.81'!
render
	
	self clearHeap.
	self mapObjectsToHeap.
	self createHeap.! !

!AMMHeap methodsFor: 'rendering' stamp: 'rm 5/6/2013 15:30:36.974'!
renderTo: anObject

	self render.
	"self lock."
	anObject addMorph: self.! !

AMMObjectsRepresentation subclass: #AMMObjectGraph
	instanceVariableNames: 'objectNodes layoutAlgorithm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:27.196'!
addNodes
| pos |
"Create one ObjectNode for every object and register the morph in the temporary storage"

self objects do:[ :obj |
|node|
	node := AMMObjectNode newFor: obj.
	
	self objectNodes at: obj put: node.
	self addMorph: node.
	].

! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:16:38.383'!
clear

	self layoutAlgorithm delete.
	self removeNodes.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:40:23.524'!
connectNode: node with: anotherNode

	| connection |
	connection := NCAAConnectorMorph fromMorph: node toMorph: anotherNode.
	connection makeForwardArrow.
	self addMorph: connection.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:31:36.037'!
connectNodes

	self objects do:[ 
		:obj|
		self connectReferences: obj. 
		]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:13:15.443'!
connectReferences: anObject

	| node |
	node := self objectNodes at: anObject.
	anObject references do: [ :ref |
		| referencedNode |
		referencedNode :=  self objectNodes at: ref.
		self connectNode: node with: referencedNode.
		]
	
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:36.428'!
delete

	self clear.
	super delete.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:12:33.76'!
initialize 

	super initialize.
	self extent: 400@400.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 13:40:23.548'!
layoutAlgorithm

	^ layoutAlgorithm ifNil: [ layoutAlgorithm := AMMGraphLayoutAlgorithm new.]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:20.328'!
layoutNodes
	WorldState
		addDeferredUIMessage: 
[ self layoutAlgorithm layoutMorph: self]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:05:48.348'!
objectNodes

	^ objectNodes ifNil: [ objectNodes := Dictionary new.]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:02:13.946'!
removeNodes 

	self removeAllMorphs.
	self objectNodes keysDo: [:key | self objectNodes removeKey: key ]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:31.14'!
render

	self addNodes.
	self connectNodes.
	self layoutNodes.
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:41:50.661'!
runGraph

	WorldState
		addDeferredUIMessage: [self layoutAlgorithm layoutMorph: self]
layoutNodes

	"move nodes"! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:00:57.498'!
clear
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:03:56.695'!
objects

	^ objects ifNil: [ objects := OrderedCollection new ]! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:20:45.861'!
objects: aCollection

	objects := aCollection! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:00:48.401'!
refresh
	self clear.
	self render. ! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 09:46:42.197'!
render
	^ self subclassResponsibility ! !

Object subclass: #AMMGCAlgorithm
	instanceVariableNames: 'objects objectStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:23:31.025'!
enter: anObject
	anObject state: #activeTraversal! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:46:50.838'!
finishStage

	(self currentStage == #clearStates) ifTrue: [ self currentStage: #traverse ].
	(self currentStage == #traverse) ifTrue: [ self currentStage: #removeObjects ].
	(self currentStage == #removeObjects) ifTrue: [  self currentStage: #done ].
	! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:17:48.834'!
gcStep
	^ self subclassResponsibility ! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:29:07.125'!
leave: anObject
	anObject state: #doneTraversal! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:42:49.585'!
nextObject
| object indexOfLastChild nextReferencedObject |
	self objectStack isEmpty ifTrue: [
		"no object was used before"
			object := self objects first.	
			self objectStack at: object put:0.
			self enter: object.		
		] ifFalse: [
			object := self objectStack orderedKeys last.
			indexOfLastChild := self objectStack at: object.
			(object references size < (indexOfLastChild +1))
				ifTrue: [ 
					" last reference of object was visited, we can leave the node now"
					self leave: object. 
					self objectStack removeKey: object.
					object := self nextObject.
					] 
				ifFalse: [
					nextReferencedObject :=  object references at: (indexOfLastChild +1).
					self objectStack at: object put:(indexOfLastChild +1).
					nextReferencedObject hasBeenTraversed 
						ifTrue: [object := self nextObject.] 
						ifFalse: [
							self enter: nextReferencedObject.
							^ nextReferencedObject ].			
					].
			].
		^ object
! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:44:01.09'!
objectStack
	^ objectStack ifNil: [ objectStack := OrderedKeysIdentityDictionary new ]! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:30.436'!
objects 
	^ objects! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:15.423'!
objects: anCollection
	objects := anCollection! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:46:26.447'!
reset
	self objects do: [ :obj | obj state: #new ].
	self currentStage: #clearStates.
	self objectStack removeAll.
	! !

AMMGCAlgorithm subclass: #AMMMarkAndSweap
	instanceVariableNames: 'currentStage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:43:27.464'!
clearAllStates
	"clear all flags of the objects"! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:42:06.508'!
currentStage

	^ currentStage! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:41:59.923'!
currentStage: aSymbol

	currentStage := aSymbol! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:45:02.918'!
gcStep 
	" 0. -> clear all states of objects -> 1. Tree traversal -> 2. remove unreferenced objects "

	(self currentStage == #clearStates) ifTrue: [ self clearAllStates ].
	(self currentStage == #traverse) ifTrue: [ self traverseTree ].
	(self currentStage == #removeObjects) ifTrue: [ self removeUnusedObjects ].
	
! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:45:18.42'!
removeUnusedObjects! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 11:43:53.583'!
traverseTree! !

Object subclass: #AMMObject
	instanceVariableNames: 'references size address state flag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:47:02.404'!
address

	^ address! !

!AMMObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:46:46.902'!
address: anAddress

	address := anAddress.! !

!AMMObject methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:35:16.035'!
flag
	" is used for the garbage collection algorithms"
	^flag! !

!AMMObject methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:35:13.053'!
flag: aSymbol
	" is used for the garbage collection algorithms"
	flag := aSymbol.! !

!AMMObject methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:40:33.526'!
hasBeenTraversed

	^ (self state == #doneTraversal) or: (self state == #activeTraversal) ! !

!AMMObject methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:36:17.351'!
initialize 
	super initialize.
	
	self flag: #new.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:39:51.902'!
references
	
	^ references ifNil: [ references := OrderedCollection new]! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:40:30.616'!
size
	
	^ size! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:40:46.006'!
size: aSize
	
	size := aSize.! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:34:17.707'!
state
	" is used for grafical representation "
	^ state! !

!AMMObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:34:26.197'!
state: aState
	" is used for grafical representation "

	state := aState.! !

RectangleMorph subclass: #AMMHeapCell
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'rm 5/6/2013 14:34:14.113'!
withId: aNumber
	| cell |
	cell := self new.
	cell extent: (10 @ 100).
	cell color: Color blue.
	cell borderWidth: 1.
	cell id: aNumber.
	^ cell.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:22:06.905'!
id
	^ id.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:24:54.733'!
id: aNumber
	id := aNumber.! !

!AMMHeapCell methodsFor: 'logic' stamp: 'rm 5/6/2013 15:06:58.379'!
reset
	self setStatus: 1.! !

!AMMHeapCell methodsFor: 'logic' stamp: 'rm 5/6/2013 15:04:46.403'!
setStatus: aState

	(aState == 1) ifTrue: [ self color: Color blue].
	(aState == 2) ifTrue: [ self color: Color red].! !

NCEllipseMorph subclass: #AMMObjectNode
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 4/30/2013 01:20:38.759'!
defaultBorderWidth 

	^ 3! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 4/30/2013 01:23:52.836'!
defaultHeight 

	^ 50
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 4/30/2013 01:23:56.352'!
defaultWidth

	^ 50
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:23:09.914'!
newFor: anObject
	| node|
	
	node := self new.
	node object: anObject.
	
	^ node! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 4/30/2013 01:23:46.289'!
initialize 
	super initialize.
	self color: Color white.
	self borderWidth: self class defaultBorderWidth.
	self removeAllMorphs.
	self height: self class defaultHeight.
	self width: self class defaultWidth.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:22:49.701'!
object

	^ object! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:22:38.518'!
object: anObject

	object := anObject.! !
